<?php
// +----------------------------------------------------------------------+
// | papaan                                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001,2002,2003 Bitflux GmbH                            |
// +----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or        |
// | modify it under the terms of the GNU General Public License (GPL)    |
// | as published by the Free Software Foundation; either version 2       |
// | of the License, or (at your option) any later version.               |
// | The GPL can be found at http://www.gnu.org/licenses/gpl.html         |
// +----------------------------------------------------------------------+
// | Author: Mike Hommey <mh@glandium.org>                                |
// +----------------------------------------------------------------------+
//
// $Id: serverpages.php,v 1.7 2003/07/29 18:03:34 glandium Exp $

include_once(PAPAAN_BASE.'/components/generator.php');
include_once(PAPAAN_BASE.'/serverpages/config.php');

/**
* @author   Mike Hommey <mh@glandium.org>
* @version  $Id: serverpages.php,v 1.7 2003/07/29 18:03:34 glandium Exp $
* @package  papaan
*/
class generator_serverpages extends generator {


    /**
    * Constructor, does nothing at the moment
    */
    function generator_file (&$sitemap, $config) {
        $this->generator($sitemap, $config);
    }

    /**
    * Initiator, called after construction of object
    *
    *  This method will be called in the start element with the attributes from this element
    *
    *  As we just call the parent init method, it's not really needed, 
    *   it's just here for reference
    *
    *  @param $attribs array    associative array with element attributes
    *  @access public
    */
    function init($attribs)
    {
        parent::init($attribs);
    }    
    
    /**
    * generates an xml-DomDocument out of the xml-file
    *
    * @access public
    * @returns object DomDocument XML-Document
    */
    function DomStart(&$xml)
    {
    	global $logicsheets;
	$CachedFile = $this->sitemap->cacheDir . '/xsp_'.$this->sitemap->generateSitemapID($this->getAttrib('src'));
	/* Buggy ; Need to do that more cleanly ; Quick and ugly hack to get it work with papaan:/ files ; should not cache at all in that case until we have a real caching system */
	if (!file_exists($this->sitemap->base_dir.'/'.$this->getAttrib('src')) || ! (file_exists($CachedFile) && (filemtime($CachedFile) >= filemtime($this->sitemap->base_dir.'/'.$this->getAttrib('src'))))) {
	        $xml = $this->readfile($this->getAttrib('src'));
		$xpath = xpath_new_context($xml);
		$xnode = xpath_eval($xpath, '//*[namespace-uri() and namespace-uri()!=\'http://apache.org/xsp\']');
		if (count($xnode->nodeset)) {
			//$current_dir = getcwd();
			foreach($xnode->nodeset as $node) {
				$ns = $node->namespace_uri();
				if(!isset($seen[$ns])) {
					$seen[$ns] = 1;
					if(isset($logicsheets[$ns])) {
						if (is_file($logicsheets[$ns])) {
							$xslt = domxml_xslt_stylesheet_file($logicsheets[$ns]);
							$xml = $xslt->process($xml);
						} else {
							papaan::raiseError('Logicsheet file not found '.$logicsheets[$ns],PAPAAN_ERROR_FATAL);
						}
					}
				}
			}
		}
		$xslt = domxml_xslt_stylesheet_file($logicsheets['http://apache.org/xsp']);
		$xml = $xslt->process($xml);
		$xslt->result_dump_file($xml, $CachedFile);
	}
	$xml = include($CachedFile);
	return True;
    }

    
    /* CACHING STUFF */

    /**
     * Generate cacheKey
     *
     * Calls the method inherited from 'Component'
     *
     * @param   array  attributes
     * @param   int    last cacheKey
     * @see     generateKeyDefault()
     */
    function generateKey($attribs, $keyBefore){
        return($this->generateKeyDefault($attribs, $keyBefore));
    }

    /** Generate validityObject  
     *
     * This is common to all "readers", you'll find the same code there.
     * I'm thinking about making a method in the class component named generateValidityFile() or alike
     * instead of having the same code everywhere..
     *
     * @author Hannes Gassert <hannes.gassert@unifr.ch>
     * @see  checkvalidity()
     * @return  array  $validityObject contains the components attributes plus file modification time and time of last access.
     */
    function generateValidity(){
        $validityObject = $this->attribs;
        $src = $this->getAttrib('src');
        $validityObject['filemtime'] = filemtime($src);
        $validityObject['fileatime'] = fileatime($src);
        return($validityObject);
    }

    /**
     * Check validity of a validityObject from cache
     *
     * This implements only the most simple form: If there's no fresher version, take that from cache.
     * I guess we'll need some more refined criteria..
     *
     * @return  bool  true if the validityObject indicates that the cached version can be used, false otherwise.
     * @param   object  validityObject
     */
    function checkValidity($validityObject){
        return(isset($validityObject['src'])       &&
               isset($validityObject['filemtime']) &&
               file_exists($validityObject['src']) &&
               ($validityObject['filemtime'] == filemtime($validityObject['src'])));
    }

}


?>
