<?php
// +----------------------------------------------------------------------+
// | papaan                                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001,2002,2003 Bitflux GmbH                            |
// +----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or        |
// | modify it under the terms of the GNU General Public License (GPL)    |
// | as published by the Free Software Foundation; either version 2       |
// | of the License, or (at your option) any later version.               |
// | The GPL can be found at http://www.gnu.org/licenses/gpl.html         |
// +----------------------------------------------------------------------+
// | Author: Mike Hommey <mh@glandium.org>                                |
// +----------------------------------------------------------------------+
//
// $Id: browser.php,v 1.3 2003/07/12 09:22:43 glandium Exp $

include_once(PAPAAN_BASE.'/components/selector.php');

/**
* Checks browser type
*
* @author   Mike Hommey <mh@glandium.org>
* @version  $Id: browser.php,v 1.3 2003/07/12 09:22:43 glandium Exp $
* @package  papaan
*/
class selector_browser extends selector
{
	var $current_agent = '';

    function selector_browser (&$sitemap, $config) {

		parent::selector($sitemap, $config);
		if (isset($_SERVER['HTTP_USER_AGENT'])) {
			// Quick and dirty way ; should check more cleanly if there's no garbage in configuration
			$xpath = xpath_new_context($this->config['dom']);
			$xnode = xpath_eval($xpath,'/config/browser');
			foreach($xnode->nodeset as $node) {
				if (is_int(strpos($_SERVER['HTTP_USER_AGENT'],$node->get_attribute('useragent')))) {
					$this->current_agent = $node->get_attribute('name');
					break;
				}
			}
		}
    }

	function test($value)
    {
		return ($value == $this->current_agent);
	}
}
